/* 
    This file is part of the ChemCon molecular mechanics 
    and molecular graphics program.

    Copyright (C) 1997-2002  Alexei Nikitin 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef TEST_BOND_ENERGY_H
#define TEST_BOND_ENERGY_H

#ifndef BOND_ENERGY_H
#include "Bond_energy.h"
#endif

#ifndef MM_BOND_LENGTH_H
#include "AMBER_bond_energy.h"
#endif

#ifndef OWN_H
#include "Own.h"
#endif


namespace MM
{

template <class T> class Array_of;

class Test_bond_energy : public Bond_energy
{
private:
    Own <Array_of <AMBER_bond_energy> > bond_lengths_;

protected:
    virtual double handle_value () const ;

public:
    Test_bond_energy (Array_of <AMBER_bond_energy> * adopt_bond_lengths);
};

}//MM

#endif //TEST_BOND_ENERGY_H

